#ifndef QUIZ_H
#define QUIZ_H

#include "Word.h"
#include <string>
#include <vector>
#include <map>
#include <fstream>

class Quiz
{
    std::string question1, question2, description, charset;
	int bins, askbothways;
    std::vector <Word> words;
    std::map <std::string, std::string, std::less<std::string> > wordmap;
    std::string fileName;
    int fileTimeStamp;
    
    int totalDuration;
    int sessions;
    int counter; 
    std::string hint;
    
    bool isValid; // valid after successfully loading
    
    std::vector<Word>::iterator currentWord;
    // currentWord == words.end() if there is no current Word yet.
    
    int binCount[MAXBINS];
public:
    bool LoadLesson (const std::string &newFileName);
    
    bool IsFinished() const;
    bool IsValid() const { return isValid; } 
    void NextQuestion();
    void Reset();
    bool CompareAnswer (std::string &a);
    std::string GetCorrectAnswer ();
    std::string GetQuestion ();
    bool HasHint () const;
	const std::string &GetHint () const { return hint; };
    
    void GetMostDifficult (std::vector <Word> &result, unsigned int amount);
    int GetCounter () const { return counter; }
    int GetBins () const { return bins; }
    int GetBinCount (int b) const { return binCount[b]; }
    void SetBins (int newCount);
    int GetWordCount () const { return words.size(); }
    Quiz();
    bool Deserialize (std::fstream &f);
    bool Serialize (std::fstream &f) const;    
	const std::string &GetFileName () const { return fileName ; }
};

#endif
